Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -1265,92 +1318,118 @@
              / ( ABS( v_comp(k) - gv ) +1.0E-20 ) )                           &
              *   weight_substep(intermediate_timestep_count)
+!
+!--        Statistical Evaluation of w'v'.
+           sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                        &
+                              + ( flux_t(k) + diss_t(k) )                     &
+                              *   weight_substep(intermediate_timestep_count)
 
        ENDDO
-       sums_vs2_ws_l(nzb_v_inner(j,i),tn) = sums_vs2_ws_l(nzb_v_inner(j,i)+1,tn)  
-                                           
-!
-!--    Vertical advection, degradation of order near surface and top. 
-!--    The fluxes flux_d and diss_d at the surface are 0. Due to reasons of
-!--    statistical evaluation the top flux at the surface should be 0
-       flux_t(nzb_v_inner(j,i)) = 0.0  !statistical reasons
-       diss_t(nzb_v_inner(j,i)) = 0.0
-!
-!--    2nd order scheme (bottom)      
-       k         = nzb_v_inner(j,i)+1
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1) 
-       w_comp    = w(k,j-1,i) + w(k,j,i)
-       flux_t(k) = w_comp * ( v(k+1,j,i) + v(k,j,i) ) * 0.25
-       diss_t(k) = diss_2nd( v(k+2,j,i), v(k+1,j,i), v(k,j,i), 0.0, 0.0,      &
-                             w_comp, 0.25, ddzw(k) ) 
-
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                    &
-                                 -   flux_d    - diss_d       ) * ddzw(k)
-        
-!
-!--    WS3 as an intermediate step (bottom)
-       k         = nzb_v_inner(j,i)+2
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       w_comp    = w(k,j-1,i) + w(k,j,i)
-       flux_t(k) = w_comp * (                                                 &
-                   7.0 * ( v(k+1,j,i) + v(k,j,i)   )                          &
-                 -       ( v(k+2,j,i) + v(k-1,j,i) ) ) * adv_mom_3
-       diss_t(k) = - ABS( w_comp ) * (                                        &
-                   3.0 * ( v(k+1,j,i) - v(k,j,i)   )                          & 
-                 -       ( v(k+2,j,i) - v(k-1,j,i) ) ) * adv_mom_3
-
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                    &
-                                 -   flux_d    - diss_d       ) * ddzw(k)
-!                                 
-!--    WS5
-       DO  k = nzb_v_inner(j,i)+3, nzt-2
-          flux_d    = flux_t(k-1)
-          diss_d    = diss_t(k-1)
+
+       DO  k = nzb_max+1, nzt
+
+          u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
+          flux_r(k) = u_comp * (                                           &
+                      37.0 * ( v(k,j,i+1) + v(k,j,i)   )                   &
+                    -  8.0 * ( v(k,j,i+2) + v(k,j,i-1) )                   &
+                    +        ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
+
+          diss_r(k) = - ABS( u_comp ) * (                                  &
+                      10.0 * ( v(k,j,i+1) - v(k,j,i) )                     &
+                    -  5.0 * ( v(k,j,i+2) - v(k,j,i-1) )                   &
+                    +        ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
+
+
+          v_comp(k) = v(k,j+1,i) + v(k,j,i)
+          flux_n(k) = ( v_comp(k) - gv ) * (                               &
+                      37.0 * ( v(k,j+1,i) + v(k,j,i)   )                   &
+                    -  8.0 * ( v(k,j+2,i) + v(k,j-1,i) )                   &
+                      +      ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
+
+          diss_n(k) = - ABS( v_comp(k) - gv ) * (                          &
+                      10.0 * ( v(k,j+1,i) - v(k,j,i)   )                   &
+                    -  5.0 * ( v(k,j+2,i) - v(k,j-1,i) )                   &
+                    +        ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),26,1)
+          k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),24,1)  )
+          k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),26,1)
+
           w_comp    = w(k,j-1,i) + w(k,j,i)
-          flux_t(k) = w_comp * (                                              &
-                      37.0 * ( v(k+1,j,i) + v(k,j,i)   )                      &           
-                    -  8.0 * ( v(k+2,j,i) + v(k-1,j,i) )                      &
-                    +      ( v(k+3,j,i) + v(k-2,j,i) ) ) * adv_mom_5
-          diss_t(k) = - ABS( w_comp ) * (                                     &
-                      10.0 * ( v(k+1,j,i) - v(k,j,i)   )                      & 
-                    -  5.0 * ( v(k+2,j,i) - v(k-1,j,i) )                      &
-                    +        ( v(k+3,j,i) - v(k-2,j,i) ) ) * adv_mom_5
-
-          tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                 &
-                                 -   flux_d    - diss_d       ) * ddzw(k)
+          flux_t(k) = w_comp  * (                                            &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),24,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( v(k+1,j,i)   + v(k,j,i)    )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( v(k_pp,j,i)  + v(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( v(k_ppp,j,i) + v(k_mm,j,i) )                  &
+                                 )
+
+          diss_t(k) = - ABS( w_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),24,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( v(k+1,j,i)   - v(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( v(k_pp,j,i)  - v(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( v(k_ppp,j,i) - v(k_mm,j,i) )                  &
+                                         )
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities introduced
+!--       by a not sufficient reduction of divergences near topography.
+          div = ( ( u_comp + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx      &
+               +  ( v_comp(k)   - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy      &
+               +  ( w_comp      - ( w(k-1,j-1,i) + w(k-1,j,i) ) ) * ddzw(k)  &
+                ) * 0.5
+
+          tend(k,j,i) = tend(k,j,i) - (                                       &
+                         ( flux_r(k) + diss_r(k)                              &
+                       -   flux_l_v(k,j,tn) - diss_l_v(k,j,tn)   ) * ddx      &
+                       + ( flux_n(k) + diss_n(k)                              &
+                       -   flux_s_v(k,tn) - diss_s_v(k,tn)       ) * ddy      &
+                       + ( flux_t(k) + diss_t(k)                              &
+                       -   flux_d    - diss_d                    ) * ddzw(k)  &
+                                      ) + v(k,j,i) * div
+
+           flux_l_v(k,j,tn) = flux_r(k)
+           diss_l_v(k,j,tn) = diss_r(k)
+           flux_s_v(k,tn)   = flux_n(k)
+           diss_s_v(k,tn)   = diss_n(k)
+           flux_d           = flux_t(k)
+           diss_d           = diss_t(k)
+
+!
+!--        Statistical Evaluation of v'v'. The factor has to be applied for
+!--        right evaluation when gallilei_trans = .T. .
+           sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                          &
+             + ( flux_n(k)                                                    &
+             * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                             &
+             / ( v_comp(k) - gv + 1.0E-20 )                                   &
+             +   diss_n(k)                                                    &
+             *   ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )                        &
+             / ( ABS( v_comp(k) - gv ) +1.0E-20 ) )                           &
+             *   weight_substep(intermediate_timestep_count)
+!
+!--        Statistical Evaluation of w'v'.
+           sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                         &
+                              + ( flux_t(k) + diss_t(k) )                      &
+                              *   weight_substep(intermediate_timestep_count)
+
        ENDDO
-!
-!--    WS3 as an intermediate step (top)
-       k         = nzt - 1
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       w_comp    = w(k,j-1,i) + w(k,j,i)
-       flux_t(k) = w_comp * (                                                 &
-                   7.0 * ( v(k+1,j,i) + v(k,j,i)   )                          &    
-                 -       ( v(k+2,j,i) + v(k-1,j,i) ) ) * adv_mom_3
-       diss_t(k) = - ABS( w_comp ) * (                                        &
-                   3.0 * ( v(k+1,j,i) - v(k,j,i) )                            & 
-                 -       ( v(k+2,j,i) - v(k-1,j,i) ) ) * adv_mom_3
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                    &
-                                 -   flux_d    - diss_d       ) * ddzw(k)
-!
-!--    2nd order scheme (top)
-       k         = nzt
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       w_comp    = w(k,j-1,i)+w(k,j,i)
-       flux_t(k) = w_comp * ( v(k+1,j,i) + v(k,j,i) ) * 0.25
-       diss_t(k) = diss_2nd( v(k+1,j,i), v(k+1,j,i), v(k,j,i), v(k-1,j,i),    &
-                             v(k-2,j,i), w_comp, 0.25, ddzw(k) )
- 
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                    &
-                                 -   flux_d    - diss_d       ) * ddzw(k)
-              
-       DO  k = nzb_v_inner(j,i), nzt
-          sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                               &
-                 + ( flux_t(k) + diss_t(k) )                                  &
-                 *   weight_substep(intermediate_timestep_count) 
-       ENDDO
+       sums_vs2_ws_l(nzb,tn) = sums_vs2_ws_l(nzb+1,tn)
+
 
     END SUBROUTINE advec_v_ws_ij
